/**
 * @desc Let the order of adding ids to aria element by DOM order, so that the screen reader
 * respects visual order when reading:
 * https://developers.google.com/web/fundamentals/accessibility/focus/dom-order-matters
 * @param {HTMLElement[]} descriptionElements - holds references to description or label elements whose
 * id should be returned
 * @param {Object} opts
 * @param {boolean} [opts.reverse]
 * @returns {HTMLElement[]} sorted set of elements based on dom order
 */
export function getAriaElementsInRightDomOrder(descriptionElements: HTMLElement[], { reverse }?: {
    reverse?: boolean | undefined;
}): HTMLElement[];
